Bug 970809 - cupsd fails to start if configured to listen on not-yet-configured IP addresses
cupsd fails to start if configured to listen on not-yet-configured IP addresses
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: cups (Show other bugs)
18
i686 Linux
unspecified Severity unspecified
: ---
: ---
Assigned To: Tim Waugh
Fedora Extras Quality Assurance
: Patch
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-06-04 20:49 EDT by Frantisek Hanzlik
Modified: 2015-02-10 09:17 EST (History)
11 users (show)

See Also:
Fixed In Version: cups-1.7-0.7.b1.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2014-02-05 18:10:51 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Frantisek Hanzlik 2013-06-04 20:49:49 EDT
Description of problem:
When specify network interfaces in /etc/cups/cupsd.conf in 'Listen' directive (e.g.
Listen localhost:631
Listen 192.168.0.250:631  
Listen 192.168.2.250:631  
)
then after system boot I will get cupsd listening only on loopback. Merging messages and cupsd logs according to time I have some as:

Jun  5 01:44:00 klempak kernel: [    0.652548] loop: module loaded
Jun  5 01:44:00 klempak kernel: [    8.054364] e100 0000:07:00.0 eth0: addr 0xe0125000, irq 21, MAC addr 00:d0:b7:55:1a:b3
Jun  5 01:44:00 klempak kernel: [    8.078727] e100 0000:07:01.0 eth1: addr 0xe0124000, irq 22, MAC addr 00:02:b3:bb:7f:e3
Jun  5 01:44:00 klempak kernel: [    8.323997] e1000e 0000:00:19.0 eth2: (PCI Express:2.5GT/s:Width x1) 00:19:d1:e0:ef:c0
Jun  5 01:44:00 klempak kernel: [    8.325961] e1000e 0000:00:19.0 eth2: Intel(R) PRO/1000 Network Connection
Jun  5 01:44:00 klempak kernel: [    8.327943] e1000e 0000:00:19.0 eth2: MAC: 6, PHY: 6, PBA No: FFFFFF-0FF
Jun  5 01:44:01 klempak network[827]: Aktivování rozhraní loopback:  [  OK  ]

I [05/Jun/2013:01:44:02 +0200] Full reload complete.
I [05/Jun/2013:01:44:02 +0200] Cleaning out old files in "/var/spool/cups/tmp"...
I [05/Jun/2013:01:44:02 +0200] Cleaning out old files in "/var/cache/cups"...
E [05/Jun/2013:01:44:02 +0200] Unable to open listen socket for address [v1.::1]:631 - Address family not supported by protocol.
I [05/Jun/2013:01:44:02 +0200] Listening to 127.0.0.1:631 on fd 11...  
E [05/Jun/2013:01:44:02 +0200] Unable to bind socket for address 192.168.0.250:631 - Cannot assign requested address.
E [05/Jun/2013:01:44:02 +0200] Unable to bind socket for address 192.168.2.250:631 - Cannot assign requested address.
I [05/Jun/2013:01:44:02 +0200] Listening to /var/run/cups/cups.sock:631 on fd 3...
I [05/Jun/2013:01:44:02 +0200] Resuming new connection processing...

Jun  5 01:44:04 klempak kernel: [   16.085595] e1000e: eth0 NIC Link is Up 1000 Mbps Full Duplex, Flow Control: None
Jun  5 01:44:04 klempak network[827]: Aktivuji rozhraní eth0:  [  OK  ]
Jun  5 01:44:07 klempak kernel: [   19.077266] e100 0000:07:01.0 eth3: NIC Link is Up 100 Mbps Full Duplex
Jun  5 01:44:07 klempak network[827]: Aktivuji rozhraní eth2:  [  OK  ]
Jun  5 01:44:09 klempak network[827]: Aktivuji rozhraní eth3:  [  OK  ]

As is evident, cupsd tries bind to interface address several seconds before they are inicialized (e.g. 7 seconds before is initialized eth3).

Version-Release number of selected component (if applicable):
systemd-201-2.fc18.7.i686
cups-1.5.4-20.fc18.i686

How reproducible:
Always - for five reboots I have no successful cupsd start with listening on all interfaces.

Additional info:
Interfaces are started by '/etc/init.d/network' script
Comment 1 Michal Schmidt 2013-06-05 05:55:46 EDT
Please avoid expletives.

As a general rule, please always file service-specific issues against the service's package at first, because in most cases that's where the bug is.

[Reassigning to cups.]

To cups maintainers:
Could cups use the IP_FREEBIND socket option (man 7 ip)? It would allow it to start listening regardless of the current state of the network interfaces.

To the reporter:
As a workaround, you can add the "After=network.target" ordering dependency to cups.service, for example by saving this fragment as /etc/systemd/system/cups.service.d/workaround.conf :

[Unit]
After=network.target
Comment 2 Tim Waugh 2013-06-20 07:02:50 EDT
I'm building cups-1.7-0.7.b1.fc20 in rawhide with the change to use IP_FREEBIND.  If there are no problems with it we can consider back-porting that to released versions later.
Comment 3 Fedora End Of Life 2013-12-21 10:32:35 EST
This message is a reminder that Fedora 18 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 18. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '18'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 18's end of life.

Thank you for reporting this issue and we are sorry that we may not be 
able to fix it before Fedora 18 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior to Fedora 18's end of life.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 4 Fedora End Of Life 2014-02-05 18:10:51 EST
Fedora 18 changed to end-of-life (EOL) status on 2014-01-14. Fedora 18 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.